/**
 * 故障预警
 */
HYX.namespace("encFaultwarning");
HYX.encFaultwarning = (function() {
	var StateAbnormalitylist;
	/**
     * 跳向故障预警页面
    */
	var goToencFaultwarningPage=function(){
		$.router.loadPage("#encFaultwarningpage");
		var conmtHei = $('.conmt_top').height();
		$('.content_head').css('margin-top',conmtHei);
		HYX.encFaultwarning.getfindStateAbnormality();
		//初始化清空列表
		$('#encFaultwarninglist').html('');
		HYX.encFaultwarning.loadRefresh();  //下拉刷新方法
		//HYX.encFaultwarning.loadInfinite();  //上拉加载方法
	};
	
	
	/**
   * 获取设备故障列表
   */
	var getfindStateAbnormality=function(){
		var today = HYX.encFaultwarning.getNowFormatDate();
		var searchValuesParam = $('#own_fault_searchContent').val();
		var param = {
			"page":1,
			"searchValuesParam":searchValuesParam,
			"rows":10,
			"startDate":"2000-01-01",
			"endDate":today
		};
		//开启进度条
		$.showIndicator();
		$.ajax({
			type : "get",
			url: basePath + "findGzInfoData",
			dataType : "jsonp",
			data : param,
			jsonp : "callback",
	  		jsonpCallback : "success_jsonpCallback",
			success: function(data){
				//关闭进度条
				$.hideIndicator();
				var error=data.error;
				if("undefined" != typeof(error)){
					HYX.util.error(error);
					return;
				}
				
				if(!data.flag || data.content.list.length == 0 || typeof(data.content.list.length) == 'undefined' || data.content.list == null || data.content.list == 'null'){
					$.toast('暂无故障数据！');
					$('#encFaultwarninglist').html('<img src="img/zwsj.png" style="width:3.6rem;display:block;margin:2rem auto 0.6rem;"/><span style="display:block;text-align: center;color: #bfbfbf;">暂无数据</span>');
				}else{
					StateAbnormalitylist=data.content.list;
					HYX.encFaultwarning.xuanranStateAbnormality(0,'');
				}    
			},
			timeout:9000,
			error:function(XMLHttpRequest, textStatus, errorThrown){
				$.hideIndicator();
				if(textStatus == "timeout"){
					$.toast("获取超时");
				}else{
					$.toast("获取失败,请重试");
				}
			}
		});
	}
	 
	//获取当前时间，格式YYYY-MM-DD
    var getNowFormatDate = function() {
        var date = new Date();
        var seperator1 = "-";
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var strDate = date.getDate();
        if (month >= 1 && month <= 9) {
            month = "0" + month;
        }
        if (strDate >= 0 && strDate <= 9) {
            strDate = "0" + strDate;
        }
        var currentdate = year + seperator1 + month + seperator1 + strDate;
        return currentdate;
    }
	
	/**
	   * 获渲染设备故障列表
	   */
	  var xuanranStateAbnormality=function(screenId,searchDta){
		  $("#encFaultwarninglist").html("");
		  var nowday=HYX.encFaultwarning.CurentTime();
		  var html="";
		  var nnew = 0;
		  var newfault = new Array();  //声明数组保存查询出来的数据
		  
		  var newfault3 = new Array();  //声明数组保存查询出来的数据
		  var newfault5 = new Array();
		  var newfault7 = new Array();
		  
		  
		  if(searchDta!=""){
			  var nnew = 0;
			  for(var i = 0;i<StateAbnormalitylist.length;i++){
				  if(StateAbnormalitylist[i].devid.indexOf(searchDta)>-1 || StateAbnormalitylist[i].encbank.indexOf(searchDta)>-1 || StateAbnormalitylist[i].encregion.indexOf(searchDta)>-1 || StateAbnormalitylist[i].encurbandistrict.indexOf(searchDta)>-1){
					  newfault[nnew] = StateAbnormalitylist[i];
					  nnew++;
				  }
			  }
		  }else{
			  newfault = StateAbnormalitylist;
		  }
		  //关闭进度条
	      $.hideIndicator();
		  for(var i=0;i<newfault.length;i++){
			  var encday=newfault[i].nrdate;
				  
			  html += '<div class="s_cont">';
			  html += '<div class="s_cont_top">';
			  html += '<div class="s_cont_left">';
			  html += '<img src="img/s_login_ENC-100.png">';
			  html += '</div>';
			  html += '<div class="s_cont_mid">';
			  html += '<span class="encMap_span">'+newfault[i].devid+'-'+newfault[i].encbank+'<img src="img/sayno2.png" class="encMap_stateImg"/></span>';
			  html += '<label class="encMap_address">'+newfault[i].location_info+'</label>';
			  html += '<span class="encMap_time">'+newfault[i].nrdate+'</span>';
			  html += '</div>';
			  html += '</div>';
			  html += '</div>';
			  
		  }
		  if(html == ""){
			  $('#encFaultwarninglist').html('<img src="img/zwsj.png" style="width:3.6rem;display:block;margin:2rem auto 0.6rem;"/><span style="display:block;text-align: center;color: #bfbfbf;">暂无数据</span>');
		  }else{
			  $("#encFaultwarninglist").html(html);
		  }
	  }
	  
	  
	  /**
	   * 筛选
	   */
	  var sreenFaultwarning = function (bid,e){
		  $(e).css('font-weight','bold').siblings().css('font-weight','100');
		  var searchDta = $.trim($("#own_fault_searchContent").val()); //获取搜索值
		  HYX.encFaultwarning.xuanranStateAbnormality(bid,searchDta);
	  }
	  
	  //搜索数据接口
	  var searchFaultwarning = function(){
		  //开启进度条
		  $.showIndicator();
		  var searchDta = $.trim($("#own_fault_searchContent").val()); //获取搜索值
		  HYX.encFaultwarning.xuanranStateAbnormality(0,searchDta);
	  };
	  
	  /**
	   * 获取当前时间
	   */
	  var  CurentTime=function(){

		  var now = new Date();  
		    
		  var year = now.getFullYear();       //年  
		  var month = now.getMonth() + 1;     //月  
		  var day = now.getDate();            //日  
		    
		  var hh = now.getHours();            //时  
		  var mm = now.getMinutes();          //分  
		  var ss = now.getSeconds();           //秒  
		    
		  var clock = year + "-";  
		    
		  if(month < 10)  
		      clock += "0";  
		    
		  clock += month + "-";  
		    
		  if(day < 10)  
		      clock += "0";  
		        
		  clock += day + " ";  
		    
		  if(hh < 10)  
		      clock += "0";  
		        
		  clock += hh + ":";  
		  if (mm < 10) clock += '0';   
		  clock += mm + ":";   
		     
		  if (ss < 10) clock += '0';   
		  clock += ss;   
		  return(clock);   
		}
	  
	  
	  /**
	   * 获取时间差值
	   */
	  var dateDiff=function(date1, date2){ 
		    var type1 = typeof date1, type2 = typeof date2; 
		    if(type1 == 'string') 
		    date1 = HYX.encFaultwarning.stringToTime(date1); 
		    else if(date1.getTime) 
		    date1 = date1.getTime(); 
		    if(type2 == 'string') 
		    date2 = HYX.encFaultwarning.stringToTime(date2); 
		    else if(date2.getTime) 
		    date2 = date2.getTime(); 
		    return (date1 - date2) / 1000;//除1000是毫秒，不加是秒 
		}
		 
	  /**
	   * 	//字符串转成Time(dateDiff)所需方法 
	   */
	   var stringToTime=function(string){ 
		    var f = string.split(' ', 2); 
		    var d = (f[0] ? f[0] : '').split('-', 3); 
		    var t = (f[1] ? f[1] : '').split(':', 3); 
		    return (new Date( 
		    parseInt(d[0], 10) || null, 
		    (parseInt(d[1], 10) || 1)-1, 
		    parseInt(d[2], 10) || null, 
		    parseInt(t[0], 10) || null, 
		    parseInt(t[1], 10) || null, 
		    parseInt(t[2], 10) || null 
		    )).getTime(); 
		} 
	   //下拉刷新
		var loadRefresh = function(){
			$(document).on('refresh', '#encFaultwarningpage .pull-to-refresh-content',function(e) {
			    setTimeout(function() {
			    	HYX.encFaultwarning.searchFaultwarning();
			        // done
			        $.pullToRefreshDone('#encFaultwarningpage .pull-to-refresh-content');
			    }, 2000);
			});
		};
	

  
	return {
		goToencFaultwarningPage : goToencFaultwarningPage,
		getfindStateAbnormality:getfindStateAbnormality,
		xuanranStateAbnormality:xuanranStateAbnormality,
		CurentTime:CurentTime,
		dateDiff:dateDiff,
		stringToTime:stringToTime,
		sreenFaultwarning:sreenFaultwarning,
		searchFaultwarning:searchFaultwarning,
		loadRefresh:loadRefresh,
		getNowFormatDate:getNowFormatDate
	};
})();