/**
 * 主页JS
 */
HYX.namespace("customerIndexPage");
HYX.customerIndexPage = (function() {
  /**
   * 跳向主页需要执行的方法
   */
	
	var marker,map;
	var data_info = ""; //全局化数据
	var newdata = "";
	var html = "";
	var cvrhtml = "";
	var onload = false;
	var goTocustomerIndexPageMethod=function(){
		HYX.customerIndexPage.goTocustomer_amap();
		HYX.customerIndexPage.searchVertion();
		HYX.customerIndexPage.loadData(0,0);
		$("#city-picker a").cityPicker({
		    toolbarTemplate: '<header class="bar bar-nav">\
		    <button class="button button-link pull-right close-picker" onclick="HYX.customerIndexPage.cityChoice();">确定</button>\
		    <h1 class="title">选择地区</h1>\
		    </header>'
		});
		var navhei = $('.bar-nav').height();
		var tshei = $('.customer_ts').height();
		var winhei = $(window).height();
		$('.indexAuto').css('height',winhei-navhei-tshei);
	};
	
	//地图初始化方法
	var goTocustomer_amap = function(){
		//开启进度条
		$.showIndicator();
		map = new AMap.Map('customer_amap', {
			resizeEnable: true,
			//center: [106.54453, 29.559662],
			zoom: 12
		});
		map.plugin(["AMap.MouseTool"], function() {
            var mouseTool = new AMap.MouseTool(map);
        });
        var options = {
            enableHighAccuracy: true,
            maximumAge: 1000,
            timeout:10000
        }
        navigator.geolocation.getCurrentPosition(
            function(position) {
                 //关闭进度条
                $.hideIndicator();
                var gps = [position.coords.longitude, position.coords.latitude];
                AMap.convertFrom(gps, 'gps', function (status, result) {
                  if (result.info == 'ok') {
                    var lnglats = result.locations; // Array.<LngLat>
                    HYX.customerIndexPage.onComplete(lnglats[0]); //返回定位信息
                  }else{
                    HYX.customerIndexPage.onError(); //返回定位出错信息
                  }
                });
            }, function onError(error) {
                //关闭进度条
                $.hideIndicator();
                if(error.code === 1){
                  $.toast("请打开共享位置信息!");
                }else if(error.code === 2){
                  $.toast("请检查网络及GPS是否开启!");
                }else if(error.code === 3){
                  $.toast("获取位置信息超时!");
                }else{
                  //$.toast("获取定位失败!");
                }
                HYX.customerIndexPage.onError(); //返回定位出错信息
          }, options);
	};
	//解析定位结果-成功
	var onComplete = function(data){
		new AMap.Marker({
            icon: 'img/location_xy.png',
            position: data,
            size: new AMap.Size(20, 30),
            map: map,
            zoom: 12
        });
		map.setZoomAndCenter(12, data);
        //DMX.mainPage.getLocationAddr(geolocationData);
        //加载Marker图标
        map.getCity(function(data) {
        	if (data['province'] && typeof data['province'] === 'string') {
        		$("#cus_province").html(data['province']);
  	          	if(data['city'] == ""){
  	          		$("#cus_city").html(data['province']);
  	          	}else{
  	          		$("#cus_city").html(data['city']);
  	          	}
  	          	$("#cus_district").html(data['district']);
        	}
        });
	};
	//解析定位错误信息
	var onError = function(){
		map.getCity(function(data) {
			if (data['province'] && typeof data['province'] === 'string') {
  	          	$("#cus_province").html(data['province']);
  	          	if(data['city'] == ""){
  	          		$("#cus_city").html(data['province']);
  	          	}else{
  	          		$("#cus_city").html(data['city']);
  	          	}
  	          	$("#cus_district").html(data['district']);
  	          	//根据坐标获取地址
  	          	AMap.service(["AMap.Geocoder"], function() { 
  	            
  	          		var geocoder = new AMap.Geocoder({
  	          			radius: 50,
  	          			extensions: "base",
  	          			zoom: 12
  	          		});
  	            
  	          		//地理编码,返回地理编码结果
  	          		geocoder.getLocation(data['city'] || data['province'], function(status, result) {
  	          			if (status == 'complete' && result.info == 'OK') {
  	          			    map.setZoomAndCenter(12, result.geocodes[0].location);
  	          			}
  	          		});

  	          	});
  	       	}
        });
	};
  
	//定位之后加载数据在地图
	var customer_data = function(data_info){
		var infoWindow = new AMap.InfoWindow({offset: new AMap.Pixel(0, -30)});
		for(var i = 0; i < data_info.length; i++) {
			var spoing = data_info[i].enclal.split(',');
			marker = new AMap.Marker({
	            position: [Number(spoing[0]),Number(spoing[1])],
	            size: new AMap.Size(20, 30),
	            map: map,
	            zoom: 12
	        });
	        marker.content = data_info[i].encbank;
	        marker.on('click', function(e){
				var elat = e.target.Qi.position.lat;
				var elng = e.target.Qi.position.lng;
		        infoWindow.setContent(e.target.content);
		        infoWindow.open(map, e.target.getPosition());
		        HYX.customerIndexPage.loadData(elat,elng);
		    });
	        if(i === 0){
	        	marker.emit('click', {target: marker});
	        }
		}
	    map.setFitView();
	};
    
	
	//查询版本信息
	var searchVertion = function(){
		if(vertionId_fage){
			$.ajax({
		  		type : "get",
		  		dataType : "jsonp",
		  		url : basePath + "getUpdateVersion",
		  		success: function(data) {
		  			if("undefined" != typeof(error)){
						return;
					}
					if(!data.flag){
						return;
					}
		  			if(parseInt(data.content.REMARK1)>parseInt(vertionId)){
		  				vertionId_fage = false;
		  				$('.upvertion_cont div').html(data.content.CONTENT);
		  				$(".fixeBg").fadeIn();
		  			}
		  		}, 
		  		timeout:15000,
		  		error:function(XMLHttpRequest, textStatus, errorThrown){
		  			$.hideIndicator();
		  			if(textStatus == "timeout"){
		  				$.toast("获取超时");
		  			}else{
		  				$.toast("获取失败,请重试");
		  			}
		  		}
		  	});
		}
	}
	
	//查询地图数据
	var loadData = function(elat,elng){
		if(elat==0 && elng==0){
			//开启进度条
			$.showIndicator();
		  	$.ajax({
		  		type : "get",
		  		dataType : "jsonp",
		  		data:{bid:"1"},
		  		url : basePath + "getEncYuEA",
				jsonp : "callback",
		  		jsonpCallback : "success_jsonpCallback",
		  		success: function(data) {
		  			//关闭进度条
		  			$.hideIndicator();
		  			var error=data.error;
					if("undefined" != typeof(error)){
						HYX.util.error(error);
						return;
					}
					if(!data.flag){
						$.toast(data.messgae);
						return;
					}
					
					//查询设备台数
					if(data.content.normal == null && data.content.add == null && data.content.err == null){
						$.toast("暂无设备！");
					}
					if(data.content.normal == 'null' && data.content.add == 'null' && data.content.err == 'null'){
						$.toast("暂无设备！");
					}
					if(typeof(data.content.normal.length) == 'undefined' && typeof(data.content.add.length) == 'undefined' && typeof(data.content.err.length) == 'undefined'){
						$.toast("暂无设备！");
					}
					if(data.content.normal.length>0 || data.content.add.length>0 || data.content.err.length>0){
						data_info.length = 0;
			  			data_info = data.content.normal;
			  			data_info = data_info.concat(data.content.add);
			  			data_info = data_info.concat(data.content.err);
			  			
			  			HYX.customerIndexPage.customer_data(data_info);
			  			newdata = data_info[0];
			  			HYX.customerIndexPage.showmapData(newdata);
	  			  	}else{
	  			  		$.toast("暂无设备！");
	  			  	}
		  			
		  		}, 
		  		timeout:15000,
		  		error:function(XMLHttpRequest, textStatus, errorThrown){
		  			$.hideIndicator();
		  			if(textStatus == "timeout"){
		  				$.toast("获取超时");
		  			}else{
		  				$.toast("获取失败,请重试");
		  			}
		  		}
		  	});
		}else{
			var postiong = elng+','+elat;
			for(var i=0;i<data_info.length;i++){
				if(data_info[i].enclal==postiong){
					newdata = data_info[i];
				}
			}
			HYX.customerIndexPage.showmapData(newdata);
		}
		
	};
	
	/*加载地图数据*/
	var showmapData = function(newdata){
		cvrhtml = "";
		html = "";
		//计算硬币余量比例
		var yb10 = (newdata.coin_10_total)/390*100;
		var yb5 = (newdata.coin_5_total)/440*100;
		var yb1 = (newdata.coin_1_total)/250*100;
		var zb100 = (newdata.cash_100_total)/115*100;
		var zb50 = (newdata.cash_50_total)/115*100;
		var zb20 = (newdata.cash_20_total)/115*100;
		var zb10 = (newdata.cash_10_total)/115*100;
		var zb5 = (newdata.cash_5_total)/115*100;
		var zb1 = (newdata.cash_1_total)/115*100;
		
		
		if(newdata.encbank.indexOf('红塔')>-1){
			$('.customer_bank').html('<img src="img/hongta_bank.jpg">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('建设')>-1){
			$('.customer_bank').html('<img src="img/CBC_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('农业')>-1){
			$('.customer_bank').html('<img src="img/ABC_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('农村信用')>-1){
			$('.customer_bank').html('<img src="img/RCB_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('中国银行')>-1){
			$('.customer_bank').html('<img src="img/BOC_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('交通')>-1){
			$('.customer_bank').html('<img src="img/BCM_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('农村商业')>-1){
			$('.customer_bank').html('<img src="img/RCB_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('邮政')>-1 || newdata.encbank.indexOf('邮储')>-1){
			$('.customer_bank').html('<img src="img/PSBC_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('工商')>-1){
			$('.customer_bank').html('<img src="img/icbc_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('浦发')>-1 || newdata.encbank.indexOf('浦东发展')>-1){
			$('.customer_bank').html('<img src="img/spdb_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('广发')>-1 || newdata.encbank.indexOf('广东发展')>-1){
			$('.customer_bank').html('<img src="img/cgb_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('民生')>-1){
			$('.customer_bank').html('<img src="img/CMBC_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('中信')>-1){
			$('.customer_bank').html('<img src="img/CITIC_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('富滇')>-1){
			$('.customer_bank').html('<img src="img/FDB_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('兴和村镇')>-1){
			$('.customer_bank').html('<img src="img/YXXHRB_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('汇丰')>-1){
			$('.customer_bank').html('<img src="img/HSBC_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('招商')>-1){
			$('.customer_bank').html('<img src="img/CMB_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('光大')>-1){
			$('.customer_bank').html('<img src="img/CEB_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('华夏')>-1){
			$('.customer_bank').html('<img src="img/HXB_bank.png">'+newdata.encbank);
		}else if(newdata.encbank.indexOf('平安')>-1){
			$('.customer_bank').html('<img src="img/PAB_bank.png">'+newdata.encbank);
		}else{
			$('.customer_bank').html('<img src="img/zw_bank.jpg">'+newdata.encbank);
		}
		
		
		$('.address_detailed').html('<img src="img/mark_r.png">'+newdata.location_info);
		var spoing = newdata.enclal.split(',');
		var mapHtml = '<li><a href="#" onclick="HYX.customerIndexPage.loactionUrl(this);" bid="https://m.amap.com/search/mapview/keywords='+newdata.location_info+'&pagenum=1&cluster_state=5"><img src="img/amap_img.png" />高德地图</a></li>'+
		'<li><a href="#" onclick="HYX.customerIndexPage.loactionUrl(this);" bid="https://map.baidu.com/mobile/webapp/search/search/qt=s&wd='+newdata.location_info+'"><img src="img/baidu_img.png" />百度地图</a></li>'+
		'<li><a href="#" onclick="HYX.customerIndexPage.loactionUrl(this);" bid="https://map.qq.com/m/index/nav/spointx='+spoing[0]+'&spointy='+spoing[1]+'&eword='+newdata.location_info+'"><img src="img/tengxun_img.png" />腾讯地图</a></li>'+
		'<li><a href="#" onclick="HYX.customerIndexPage.colse_bg()">取消</a></li>';
		$('.fixe_cont ul').html(mapHtml);
		
		cvrhtml += '<canvas id="canvasIndex1" amount="10000" vote="10000" tip="50"></canvas>';
		cvrhtml += '<canvas id="canvasIndex2" amount="10000" vote="10000" tip="50"></canvas>';
		cvrhtml += '<canvas id="canvasIndex3" amount="10000" vote="10000" tip="50"></canvas>';
		
		$('#yb_canvas').html(cvrhtml);
		
		var option1={
	        percent:yb10,   //百分比数值
		    text:'1元',
		    color:'#ff0000',
		    w:80,          //宽度
		    oneCircle:"ture"  //是否是整个圆  默认半圆
	    }
	    var option2={
		    percent:yb5,   //百分比数值
		    text:'5角',
		    color:'#ffb524',
		    w:80,          //宽度
		    oneCircle:"ture"  //是否是整个圆  默认半圆
	    }
	    var option3={
		    percent:yb1,   //百分比数值
		    text:'1角',
		    color:'#417505',
		    w:80,          //宽度
		    oneCircle:"ture"  //是否是整个圆  默认半圆
	    }
	    $("#canvasIndex1").audios2(option1);
	    $("#canvasIndex2").audios2(option2);
	    $("#canvasIndex3").audios2(option3);
	    
	    html += '<span><i class="customer_zb_bg customer_100"></i><i class="customer_zb_text">100元</i></span>';
	    html += '<span><i class="customer_zb_bg customer_50"></i><i class="customer_zb_text">50元</i></span>';
	    html += '<span><i class="customer_zb_bg customer_20"></i><i class="customer_zb_text">20元</i></span>';
	    html += '<span><i class="customer_zb_bg customer_10"></i><i class="customer_zb_text">10元</i></span>';
	    html += '<span><i class="customer_zb_bg customer_5"></i><i class="customer_zb_text">5元</i></span>';
	    html += '<span><i class="customer_zb_bg customer_1"></i><i class="customer_zb_text">1元</i></span>';
	    $('#zb_messge').html(html);
	    
	    $('.customer_100').animate({width:zb100+'%'},3000);
	    $('.customer_50').animate({width:zb50+'%'},3000);
	    $('.customer_20').animate({width:zb20+'%'},3000);
	    $('.customer_10').animate({width:zb10+'%'},3000);
	    $('.customer_5').animate({width:zb5+'%'},3000);
	    $('.customer_1').animate({width:zb1+'%'},3000);
	};
	
	//跳转导航
	var loactionUrl = function(e){
		var bid = $(e).attr('bid');
		window.location.href=bid;
	};
	
	var cityShow = function(){
		$('.customer_fixe_bg').show();
	};
	var cityHide = function(){
		$('.customer_fixe_bg').hide();
	};
	
	/**
	 * light7城市选择
	 * @author hupengfei
	 */
	var cityChoice = function(){
		HYX.customerIndexPage.cityHide();
	  	var province = $('.col-province .picker-selected').html();   //省份
	  	var city = $('.col-city .picker-selected').html();  //城市
	  	var district = $('.col-district .picker-selected').html();  //城市
	  	var citynum = $('.col-city .picker-selected').index();
	  	var districtnum = $('.col-district .picker-selected').index();
	  	var prcitydis = province+""+city+''+district;
	  	if(districtnum === 0){
	  		district = "全部";
	  	}
	  	$('#cus_province').html(province);
	  	$('#cus_city').html(city);
	  	$('#cus_district').html(district);
	  	$('#city-picker').attr('bid',province);
	  	map.getCity(function(data) {
	  		AMap.service(["AMap.Geocoder"], function() {
				// 加载地理编码
			  	var geocoder = new AMap.Geocoder({radius: 50,extensions: "base"});
				// 根据地址获取坐标
				geocoder.getLocation(prcitydis,function(status, result){
					 if (status == 'complete' && result.info == 'OK') {
					    var location=(result.geocodes)[0].location;
						map.setZoomAndCenter(12,location);
						/*if(null == positionPicker) {
							DMX.mainPage.loadingdataMarker();
						}else{
							positionPicker.start(location);
						}*/
					}
				});
			});
	  	});
	};
	
	var goToIndex = function(){
		$.router.loadPage("#customerIndexPage");
	};
	
	var goToBank = function(){
		$.router.back();
	};
	//跳转列表页
	var goToenclist = function(){
		HYX.tdaEnclistPage.goTotdaEnclistPage(data_info);
		
	};
	
	//显示导航地图选择层
	var mapChoice = function (){
		var content = $('.fixe_cont ul li').length;
		if(content>0){
			$(".fixe_bg").fadeIn();
			$(".fixe_cont").slideDown();
		}else{
			$.toast("暂无数据，无法导航！");
		}
		
	}
	//隐藏导航地图选择层
	var colse_bg = function (){
		$(".fixe_bg").fadeOut();
		$(".fixe_cont").slideUp();
	}
	
	//关闭更新提示层
	var colseBg = function(){
		$(".fixeBg").fadeOut();
	}
	
	return {
		goTocustomerIndexPageMethod:goTocustomerIndexPageMethod,
		goTocustomer_amap:goTocustomer_amap,
		onComplete:onComplete,
		onError:onError,
		customer_data:customer_data,
		loadData:loadData,
		cityShow:cityShow,
		cityHide:cityHide,
		cityChoice:cityChoice,
		goToIndex:goToIndex,
		showmapData:showmapData,
		goToenclist:goToenclist,
		mapChoice:mapChoice,
		colse_bg:colse_bg,
		loactionUrl:loactionUrl,
		searchVertion:searchVertion,
		colseBg:colseBg
	};
})();