/**
 * 空机率分析-饼图展示
 */
HYX.namespace("tdaEncEmptyAreaPage");
HYX.tdaEncEmptyAreaPage = (function() {
	
  var tdaEncEmptyAreaPage_region="";
  
  var myChart = null;
  
  
  var myChart_Histogram = null;
  
  var tdaEncEmptyAreaPage_Data=null;
  
  
  var EmptyMin=0;
  
  var EmptyTotal=0;
  
  /**
   * 饼图数据分析页面
   */
  var goToTdaEncTroubleAreaPageMethod=function(region){
  	tdaEncEmptyAreaPage_region=region;
  	$.router.loadPage("#tdaEncEmptyAreaPage");
  	$("#tdaEncEmptyAreaPage_title").text(tdaEncEmptyAreaPage_region+"区域");
  	HYX.tdaEncEmptyAreaPage.initTdaEncTroubleAreaData();
  };
  
  
  /**
   * 初始化数据内容
   */
  var initTdaEncTroubleAreaData=function(){
  	
  	var param={
  	  "area" : tdaEncEmptyAreaPage_region
  	};
  	
  	// 开启进度条
    $.showIndicator();
    $.ajax({
      type : "get",
      dataType : "jsonp",
      url: basePath + "getTdaEncEmptyRegionAreaRegion",
      jsonp : "callback",
      data : param,
      jsonpCallback : "success_jsonpCallback",
      success : function(data) {
          //关闭进度条
          $.hideIndicator();
          var error=data.error;
          if("undefined" != typeof(error)){
            HYX.util.error(error);
            return;
          }
          if(!data.flag){
            $.toast(data.messgae);
            return;
          }
          EmptyMin=data.content.EmptyMin;
 		  EmptyTotal=data.content.EmptyTotal;
          tdaEncEmptyAreaPage_Data=JSON.stringify(data.content);
          HYX.tdaEncEmptyAreaPage.loadTdaEncTroubleAreaPageData(data.content.banktotal);
          HYX.tdaEncEmptyAreaPage.initTdaEncTroubleHistogram(data.content.data);
          //渲染下个页面的时间段数据
          HYX.tdaEncEmptyAreaDetailPage.setEncEmptyAreaDetailPageWindowCss(data.content.EmptyList);
      },
      timeout : 30000,
      error : function(XMLHttpRequest, textStatus, errorThrown) {
        $.hideIndicator();
        if (textStatus == "timeout") {
          $.toast("获取超时");
        } else {
        	HYX.util.error('error');
        }
      }
    });
  };
	
  
  var color=['#FF66FF','#66CCCC','#99FFCC','#99CC99','#CCFFCC','#66CC33','#339900',
  '#999900','#CCCC00','#FFFFCC','#FFCC66','#CC6600','#FF9933',
  '#990033','#FF3399','#99FFFF','#CC33FF','#660099','#99CCFF','#0033FF','#CC6699','#FF9999',
  '#CC33CC','#CC99CC','#666FF','#9933FF','#66CCFF','#CCCCFF','#FFCC00','#FF9900','#FF6633',
  '#993333','#33CCCC','#66FFCC','#339933','#00FF66','#00FF00','#33CC00','#CCFF00','#CCCC99'];
  
  
  /**
   * 渲染数据
   */
  var loadTdaEncTroubleAreaPageData=function(content){
  	
  	if(null == content || "undefined" == typeof(content) || content == "" || content.length === 0 || "null" == content){
  		$.toast("无数据");
  		return;
  	}
  	
  	if(content.length === 40){
  		$.toast("渲染数据过多,请联系管理人员");
  		return;
  	}
  	
  	var total=0;
  	for(var i=0;i<content.length;i++){
  		total+=Number(content[i].total);
  	}
  	
  	var contentArray=new Array();
  	var contentBank=new Array();
  	var contentBankColor=new Array();
  	for(var i=0;i<content.length;i++){
  		var paramContent={
			'value' : content[i].total,
			'name'  : content[i].bank
  		};
  		contentArray.push(paramContent);
  		contentBank.push(content[i].bank);
  		contentBankColor.push(color[i]);
  	}
  	
  	myChart = echarts.init(document.getElementById('tdaEncEmptyAreaPage_main'));
	
	var data=contentArray;
	
	var option = {
	    title: {
	        text: '设备台数',
	        subtext: total,
	        x: 'center',
	        y: 'center',
	        textStyle: {
	            fontWeight: 'normal',
	            fontSize: 16
	        }
	    },
	    tooltip: {
	        show: true,
	        trigger: 'item',
	        formatter: "{b}: {c} ({d}%)"
	    },
	    legend: {
	        orient: 'horizontal',
	        bottom: '0%',
	        data: contentBank
	    },
	    series: [{
	        type: 'pie',
	        selectedMode: 'single',
	        radius: ['25%', '58%'],
	        color: contentBankColor,
	        label: {
	            normal: {
	                position: 'inner',
	                formatter: '{d}%',
	                textStyle: {
	                    color: '#fff',
	                    fontWeight: 'bold',
	                    fontSize: 14
	                }
	            }
	        },
	        labelLine: {
	            normal: {
	                show: false
	            }
	        },
	        data: data
	    }, {
	        type: 'pie',
	        radius: ['58%', '83%'],
	        itemStyle: {
	            normal: {
	                color: '#DCDCDC'
	            },
	            emphasis: {
	                color: '#ADADAD'
	            }
	        },
	        label: {
	            normal: {
	                position: 'inner',
	                formatter: '{c}台',
	                textStyle: {
	                    color: '#777777',
	                    fontWeight: 'bold',
	                    fontSize: 14
	                }
	            }
	        },
	        data : data
	    }]
	};
	myChart.setOption(option);
	HYX.tdaEncEmptyAreaPage.bindTdaEncTroubleAreaPage();
  };
  
  /**
   * 绑定饼图点击事件以及银行选择事件
   */
  var bindTdaEncTroubleAreaPage=function(){
  	
  	if(null != myChart){
  		
  		//点击切换图形
  		myChart.on('click', function (params) {
	    	var name = params.data.name;
	    	HYX.tdaEncEmptyAreaDetailPage.geToTdaEncEmptyAreaDetailPageMethod(tdaEncEmptyAreaPage_region,name);
		});
		
		
		//点击银行图片
		myChart.on('legendselectchanged', function (params) {
			var myChartData=myChart.getOption();
			var _myChartData=myChartData.series[0].data;
			var total=0;
			for(var i=0;i<_myChartData.length;i++){
				var name=_myChartData[i].name;
				if(params.selected[name]){
					total+=Number(_myChartData[i].value);
				}
			}
			
			if(total === 0){
				total="无";
			}
			
			myChart.setOption({
			    title: {
		        	subtext: total
			    }
			});
			var _hData=JSON.parse(tdaEncEmptyAreaPage_Data);
			HYX.tdaEncEmptyAreaPage.setTdaEncTroubleAreaPageDataH(_hData.data,_myChartData,params);
		});
  	}
  };
  
  /**
   * 饼状图联动下面柱状图
   */
  var setTdaEncTroubleAreaPageDataH=function(hData,data,params){
  	var bankSelectedTrue=new Array();
  	for(var i=0;i<data.length;i++){
		var name=data[i].name;
		if(params.selected[name]){
			bankSelectedTrue.push(name);
		}
	}
	if(bankSelectedTrue.length === 0){
		HYX.tdaEncEmptyAreaPage.initTdaEncTroubleHistogram(bankSelectedTrue);
	}else{
		//TODO 
		var tt=new Array();
		for(var k=0;k<hData.length;k++){
			for(var i=0;i<bankSelectedTrue.length;i++){
				if(bankSelectedTrue[i] == hData[k].bank){
					tt.push(hData[k]);
				}
			}
		}
		HYX.tdaEncEmptyAreaPage.initTdaEncTroubleHistogram(tt);
	}
  };
  
  
  
  /**
   * 初始化柱状图
   * 在上面饼图中查询出了 银行 台数  至今为止,该银行所有空机台数
   * 
   * 条形图  年份  月份  银行  台数  次数
   *         2017   1    农业    5    1
   *         2017   1    招商    10   2
   * 条形图计算方式：1/5/1月份天数+2/10/1月份天数=1月份的空机率
   * 
   * 条形图  年份  月份  银行  台数  次数
   *         2017   2    农业    15   5
   *         2017   2    招商    20   10
   * 条形图计算方式：5/15/2月份天数+10/20/2月份天数=2月份的空机率
   */
  var initTdaEncTroubleHistogram=function(_histogramData){
  	var histogramData=_histogramData;
  	var yearsArray=HYX.tdaEncEmptyAreaPage.getYears(histogramData);
  	//空机次数
  	var dataArray=HYX.tdaEncEmptyAreaPage.dataSet(yearsArray,histogramData);
  	//空机空机台数
  	var dataArray1=HYX.tdaEncEmptyAreaPage.dataSet1(yearsArray,histogramData);
  	//空机空机率
  	var dataArray2=HYX.tdaEncEmptyAreaPage.dataSet2(yearsArray,histogramData);
  	
  	//设置echarts的数据
  	var dataMap = {};
  	
  	dataMap.dataGDP = HYX.tdaEncEmptyAreaPage.initTdaEncTroubleHistogramYear(dataArray1,yearsArray);
	
	dataMap.dataNumber = HYX.tdaEncEmptyAreaPage.initTdaEncTroubleHistogramYear(dataArray,yearsArray);
	
	dataMap.dataFinancial = HYX.tdaEncEmptyAreaPage.initTdaEncTroubleHistogramYear(dataArray2,yearsArray);
	
	HYX.tdaEncEmptyAreaPage._initTdaEncTroubleHistogram(yearsArray,dataMap);
  };
  
  
  var _initTdaEncTroubleHistogram=function(yearsArray,dataMap){
  	//获取echarts
  	myChart_Histogram=echarts.init(document.getElementById('tdaEncEmptyAreaPage_main1'));
  	
	var option = {
    	baseOption: {
	        timeline: {
	            axisType: 'category',
	            autoPlay: false,
	            playInterval: 2000,
	            data: yearsArray,
	            label: {
	                formatter : function(s) {
	                    return (new Date(s)).getFullYear();
	                }
	            }
	        },
	        title: {
	            subtext: ''
	        },
	        tooltip: {
	        },
	        legend: {
	            x: 'right',
	            data: ['台数', '使用次数','闲置率']
	        },
	        calculable : true,
	        grid: {
	            top: 80,
	            bottom: 100,
	            right:'10%',
	            left:'10%',
	            tooltip: {
	                trigger: 'axis',
	                axisPointer: {
	                    type: 'shadow',
	                    label: {
	                        show: true,
	                        formatter: function (params) {
	                            return params.value.replace('\n', '');
	                        }
	                    }
	                }
	            }
	        },
	        xAxis: [
	            {
	                'type':'category',
	                'data':['1月','2月','3月','4月','5月','6月','7月','8月','9月','10月','11月','12月'],
	                splitLine: {show: false}
	            }
	        ],
	        yAxis: [
	            {
	                type: 'value',
	                name: '台数/次数',
	                position: 'left'
	            },
		        {
		            type: 'value',
		            //name: '次数',
		            position: 'left',
		            axisLabel: {
		                formatter: '{value}'
		            }
		        },
		        {
		            type: 'value',
		            name: '闲置率',
		            position: 'right',
		            axisLabel: {
		                formatter: '{value}%'
		            }
		        }
	        ],
	        series: [
	            {name: '台数', type: 'bar'},
	            {name: '使用次数', type: 'bar'},
	            {name: '闲置率', type: 'bar'}
	        ]
	    },
	    options: [
	    	{
	            title : {text: '2016年'},
	            series : [
	                {data: dataMap.dataGDP['2016'],yAxisIndex: 1},
	                {data: dataMap.dataNumber['2016'],yAxisIndex: 1},
	                {data: dataMap.dataFinancial['2016'],yAxisIndex: 2}
	            ]
	        },
	        {
	            title : {text: '2017年'},
	            series : [
	                {data: dataMap.dataGDP['2017'],yAxisIndex: 1},
	                {data: dataMap.dataNumber['2017'],yAxisIndex: 1},
	                {data: dataMap.dataFinancial['2017'],yAxisIndex: 2}
	            ]
	        },
	        {
	            title : {text: '2018年'},
	            series : [
	                {data: dataMap.dataGDP['2018'],yAxisIndex: 1},
	                {data: dataMap.dataNumber['2018'],yAxisIndex: 1},
	                {data: dataMap.dataFinancial['2018'],yAxisIndex: 2}
	            ]
	        },
	        {
	            title : {text: '2019年'},
	            series : [
	                {data: dataMap.dataGDP['2019'],yAxisIndex: 1},
	                {data: dataMap.dataNumber['2019'],yAxisIndex: 1},
	                {data: dataMap.dataFinancial['2019'],yAxisIndex: 2}
	            ]
	        },
	        {
	            title : {text: '2020年'},
	            series : [
	                {data: dataMap.dataGDP['2020'],yAxisIndex: 1},
	                {data: dataMap.dataNumber['2020'],yAxisIndex: 1},
	                {data: dataMap.dataFinancial['2020'],yAxisIndex: 2}
	            ]
	        },
	        {
	            title : {text: '2021年'},
	            series : [
	                {data: dataMap.dataGDP['2021'],yAxisIndex: 1},
	                {data: dataMap.dataNumber['2021'],yAxisIndex: 1},
	                {data: dataMap.dataFinancial['2021'],yAxisIndex: 2}
	            ]
	        },
	        {
	            title : {text: '2022年'},
	            series : [
	                {data: dataMap.dataGDP['2022'],yAxisIndex: 1},
	                {data: dataMap.dataNumber['2022'],yAxisIndex: 1},
	                {data: dataMap.dataFinancial['2022'],yAxisIndex: 2}
	            ]
	        }
	    ]
	};
	myChart_Histogram.setOption(option);  	
  };
  
  
  /**
   * 时间年限格式化
   */
  var initTdaEncTroubleHistogramYear=function(obj,yearsParam){
  	var pList = ['1月','2月','3月','4月','5月','6月','7月','8月','9月','10月','11月','12月'];
  	if(null == yearsParam && yearsParam.length ===0){
  		return null;
  	}
  	
  	var maxYears=Math.max.apply(null, yearsParam);
  	var minYears=Math.min.apply(null, yearsParam);
  	
    var temp;
    for (var year = minYears; year <= maxYears; year++) {
        var max = 0;
        var sum = 0;
        temp = obj[year];
        for (var i = 0, l = temp.length; i < l; i++) {
            max = Math.max(max, temp[i]);
            sum += temp[i];
            obj[year][i] = {
                name : pList[i],
                value : temp[i]
            }
        }
        obj[year + 'max'] = Math.floor(max / 100) * 100;
        obj[year + 'sum'] = sum;
    }
    return obj;
  };
  
  /**
   * 获取年限
   */
  var getYears=function(_years){
  	var years=new Array();
  	var r = []; 
  	if(null != _years && _years.length !=0){
  		for(var i=0;i<_years.length;i++){
  			years.push(_years[i].years);
  		}
		for(var i = 0, l = years.length; i < l; i++) { 
		 for(var j = i + 1; j < l; j++) 
		  if (years[i] === years[j]) j=++i; 
		 	r.push(years[i]); 
 		} 
  	}
  	
  	var i = 0,len = r.length,j,d;
    for(;i<len;i++){
        for(j=0;j<len;j++){
            if(r[i]<r[j]){
                d=r[j];
                r[j]=r[i];
                r[i]=d;
            }
        }
    }
  	return r;
  };
  
  /**
   * 获取哪一年哪一个月的天数
   */
  var mGetDate=function(year, month){
    var d = new Date(year, month, 0);
    return d.getDate();
  };
  
  
  /**
   * 返回 年 月 空机次数
   */
  var dataSet=function(years,data){
  	  var yearsA={};
	  var pList = ["01","02","03","04","05","06","07","08","09","10","11","12"];
	  if(null != years && years.length != 0){
	  	for(var i=0;i<years.length;i++){
	  		var dataArray=new Array();
	  		for(var j=0;j<pList.length;j++){
	  			var nn=0;
	  			for(var k=0;k<data.length;k++){
	  				if(years[i] == data[k].years && pList[j] == data[k].mm){
	  					nn+=Number(data[k].con);
	  				}
	  			}
	  			dataArray.push(nn);
	  		}
	  		yearsA[years[i]]=dataArray;
	  	}
	  }
	  return yearsA;
  };
  
  /**
   * 返回 年 月 空机台数
   */
  var dataSet1=function(years,data){
  	  var yearsA={};
	  var pList = ["01","02","03","04","05","06","07","08","09","10","11","12"];
	  if(null != years && years.length != 0){
	  	for(var i=0;i<years.length;i++){
	  		var dataArray=new Array();
	  		for(var j=0;j<pList.length;j++){
	  			var nn=0;
	  			for(var k=0;k<data.length;k++){
	  				if(years[i] == data[k].years && pList[j] == data[k].mm){
	  					nn+=Number(data[k].num);
	  				}
	  			}
	  			dataArray.push(nn);
	  		}
	  		yearsA[years[i]]=dataArray;
	  	}
	  }
	  return yearsA;
  };
  
  /**
   * 返回 年 月 空机率
   */
  var dataSet2=function(years,data){
  	var getYear=(new Date()).getFullYear();
	var getMonth=(new Date()).getMonth()+1;
  	  var yearsA={};
	  var pList = ["01","02","03","04","05","06","07","08","09","10","11","12"];
	  if(null != years && years.length != 0){
	  	for(var i=0;i<years.length;i++){
	  		var dataArray=new Array();
	  		for(var j=0;j<pList.length;j++){
	  			var nn=0;
	  			var mm=0;
	  			for(var k=0;k<data.length;k++){
	  				if(years[i] == data[k].years && pList[j] == data[k].mm){
	  					nn+=Number(data[k].con);
	  					mm+=Number(data[k].num);
	  				}
	  			}
				var getDateDay=0;
				if(Number(years[i]) == Number(getYear) && Number(pList[j]) == Number(getMonth)){
					getDateDay=(new Date()).getDate();
				}else{
					getDateDay=HYX.tdaEncEmptyAreaPage.mGetDate(years[i],Number(pList[j]));
				}
				//(50/(10*28)).toFixed(2)*100
				var jlv=0;
				if(Number(mm) === 0){
					jlv=0;
				}else{
					jlv=100-parseInt(((Number(nn)*Number(EmptyMin))/((Number(mm)*Number(getDateDay))*Number(EmptyTotal))).toFixed(2)*100);
				}
				if(jlv >= 100){
					jlv=100;
				}
	  			dataArray.push(jlv);
	  		}
	  		yearsA[years[i]]=dataArray;
	  	}
	  }
	  return yearsA;
  };
  return {
    goToTdaEncTroubleAreaPageMethod : goToTdaEncTroubleAreaPageMethod,
    initTdaEncTroubleAreaData:initTdaEncTroubleAreaData,
    loadTdaEncTroubleAreaPageData:loadTdaEncTroubleAreaPageData,
    bindTdaEncTroubleAreaPage:bindTdaEncTroubleAreaPage,
    initTdaEncTroubleHistogram:initTdaEncTroubleHistogram,
    initTdaEncTroubleHistogramYear:initTdaEncTroubleHistogramYear,
    getYears:getYears,
    mGetDate:mGetDate,
    dataSet:dataSet,
    dataSet1:dataSet1,
    dataSet2:dataSet2,
    _initTdaEncTroubleHistogram:_initTdaEncTroubleHistogram,
    setTdaEncTroubleAreaPageDataH:setTdaEncTroubleAreaPageDataH
  };
})();
