/**
 * 交易数据分析-饼图展示
 */
HYX.namespace("tdaEncOneAreaPage");
HYX.tdaEncOneAreaPage = (function() {
	
  var tdaEncOneAreaPage_region="";
  
  var myChart = null;
  
  /**
   * 饼图数据分析页面
   */
  var goToTdaEncOneAreaPageMethod=function(){
  	$.router.loadPage("#tdaEncOneAreaPage");
  	HYX.tdaEncOneAreaPage.initTdaEncOneAreaData();
  	$.closePanel("#panel-js-demo");
  };
  
  
  /**
   * 初始化数据内容
   */
  var initTdaEncOneAreaData=function(){
	  HYX.tdaEncOneAreaPage.loadEncOneAreaPageData();
  };
	
  
  var color=['#FF66FF','#66CCCC','#99FFCC','#99CC99','#CCFFCC','#66CC33','#339900',
  '#999900','#CCCC00','#FFFFCC','#FFCC66','#CC6600','#FF9933',
  '#990033','#FF3399','#99FFFF','#CC33FF','#660099','#99CCFF','#0033FF','#CC6699','#FF9999',
  '#CC33CC','#CC99CC','#666FF','#9933FF','#66CCFF','#CCCCFF','#FFCC00','#FF9900','#FF6633',
  '#993333','#33CCCC','#66FFCC','#339933','#00FF66','#00FF00','#33CC00','#CCFF00','#CCCC99'];
  
  
  /**
   * 渲染数据
   */
  var loadEncOneAreaPageData=function(content){
	  var dom = document.getElementById("tdaEncOneAreaPage_main");
	  var myChart = echarts.init(dom);
	  var app = {};
	  option = null;
	  option = {
	      title : {
	          text: '交易数据分析',
	          x:'center'
	      },
	      tooltip : {
	          trigger: 'item',
	          formatter: "{a} <br/>{b} : {c} ({d}%)"
	      },
	      legend: {
	          orient: 'vertical',
	          left: 'left',
	          data: ['红塔银行','农业银行','中国银行','建设银行','工商银行']
	      },
	      series : [
	          {
	              name: '访问来源',
	              type: 'pie',
	              radius : '55%',
	              center: ['50%', '60%'],
	              data:[
	                  {value:335, name:'红塔银行'},
	                  {value:310, name:'农业银行'},
	                  {value:234, name:'中国银行'},
	                  {value:135, name:'建设银行'},
	                  {value:1548, name:'工商银行'}
	              ],
	              itemStyle: {
	                  emphasis: {
	                      shadowBlur: 10,
	                      shadowOffsetX: 0,
	                      shadowColor: 'rgba(0, 0, 0, 0.5)'
	                  }
	              }
	          }
	      ]
	  };
	  ;
	  if (option && typeof option === "object") {
	      myChart.setOption(option, true);
	  }
	  HYX.tdaEncOneAreaPage.bindEncOneAreaPage();
  };
  
  /**
   * 绑定饼图点击事件以及银行选择事件
   */
  var bindEncOneAreaPage=function(){
  	if(null != myChart){
  		myChart.on('click', function (params) {
	    	/*var name = params.data.name;*/
	    	HYX.tdaEncOneAreaDetailPage.goToTdaEncOneAreaDetailPage();
		});
	
		myChart.on('legendselectchanged', function (params) {
			var myChartData=myChart.getOption();
			var _myChartData=myChartData.series[0].data;
			var total=0;
			for(var i=0;i<_myChartData.length;i++){
				var name=_myChartData[i].name;
				if(params.selected[name]){
					total+=Number(_myChartData[i].value);
				}
			}
			
			if(total === 0){
				total="无";
			}
			myChart.setOption({
			    title: {
		        	subtext: total
			    }
			});
		});
  	}
  };
  return {
    goToTdaEncOneAreaPageMethod : goToTdaEncOneAreaPageMethod,
    initTdaEncOneAreaData:initTdaEncOneAreaData,
    loadEncOneAreaPageData:loadEncOneAreaPageData,
    bindEncOneAreaPage:bindEncOneAreaPage
  };
})();
