/**
 * 使用波段数据分析-饼图展示
 */
HYX.namespace("tdaEncbandanalysisPage");
HYX.tdaEncbandanalysisPage = (function() {
	
  var tdaEncbandanalysisPage_region="";
  
  var myChart = null;
  
  /**
   * 饼图数据分析页面
   */
  var goToTdaEncbandanalysisPageMethod=function(region){
  	tdaEncbandanalysisPage_region=region;
  	$.router.loadPage("#tdaEncbandanalysisPage");
  	$("#tdaEncbandanalysisPage_title").text(tdaEncbandanalysisPage_region+"区域");
  	HYX.tdaEncbandanalysisPage.initTdaEncbandanalysisData();
  };
  
  
  /**
   * 初始化数据内容
   */
  var initTdaEncbandanalysisData=function(){
  	
  	var param={
  	  "area" : tdaEncbandanalysisPage_region
  	};
  	
  	// 开启进度条
    $.showIndicator();
    $.ajax({
      type : "get",
      dataType : "jsonp",
      url: basePath + "getTdaOneAreaRegion",
      jsonp : "callback",
      data : param,
      jsonpCallback : "success_jsonpCallback",
      success : function(data) {
          //关闭进度条
          $.hideIndicator();
          var error=data.error;
          if("undefined" != typeof(error)){
            HYX.util.error(error);
            return;
          }
          if(!data.flag){
            $.toast(data.messgae);
            return;
          }
          HYX.tdaEncbandanalysisPage.loadEncOneAreaPageData(data.content);
      },
      timeout : 30000,
      error : function(XMLHttpRequest, textStatus, errorThrown) {
        $.hideIndicator();
        if (textStatus == "timeout") {
          $.toast("获取超时");
        } else {
        	HYX.util.error('error');
        }
      }
    });
  };
	
  
  var color=['#FF66FF','#66CCCC','#99FFCC','#99CC99','#CCFFCC','#66CC33','#339900',
  '#999900','#CCCC00','#FFFFCC','#FFCC66','#CC6600','#FF9933',
  '#990033','#FF3399','#99FFFF','#CC33FF','#660099','#99CCFF','#0033FF','#CC6699','#FF9999',
  '#CC33CC','#CC99CC','#666FF','#9933FF','#66CCFF','#CCCCFF','#FFCC00','#FF9900','#FF6633',
  '#993333','#33CCCC','#66FFCC','#339933','#00FF66','#00FF00','#33CC00','#CCFF00','#CCCC99'];
  
  
  /**
   * 渲染数据
   */
  var loadEncOneAreaPageData=function(content){
  	
  	if(null == content || "undefined" == typeof(content) || content == "" || content.length === 0 || "null" == content){
  		$.toast("无数据");
  		return;
  	}
  	
  	if(content.length === 40){
  		$.toast("渲染数据过多,请联系管理人员");
  		return;
  	}
  	
  	var total=0;
  	for(var i=0;i<content.length;i++){
  		total+=Number(content[i].total);
  	}
  	
  	var contentArray=new Array();
  	var contentBank=new Array();
  	var contentBankColor=new Array();
  	for(var i=0;i<content.length;i++){
  		var paramContent={
			'value' : content[i].total,
			'name'  : content[i].bank
  		};
  		contentArray.push(paramContent);
  		contentBank.push(content[i].bank);
  		contentBankColor.push(color[i]);
  	}
  	
  	myChart = echarts.init(document.getElementById('tdaEncbandanalysisPage_main'));
	
	var data=contentArray;
	
	option = {
	    backgroundColor: '#fff',
	    title: {
	        text: '设备台数',
	        subtext: total,
	        x: 'center',
	        y: 'center',
	        textStyle: {
	            fontWeight: 'normal',
	            fontSize: 16
	        }
	    },
	    tooltip: {
	        show: true,
	        trigger: 'item',
	        formatter: "{b}: {c} ({d}%)"
	    },
	    legend: {
	        orient: 'horizontal',
	        bottom: '0%',
	        data: contentBank
	    },
	    series: [{
	        type: 'pie',
	        selectedMode: 'single',
	        radius: ['25%', '58%'],
	        color: contentBankColor,
	        label: {
	            normal: {
	                position: 'inner',
	                formatter: '{d}%',
	                textStyle: {
	                    color: '#fff',
	                    fontWeight: 'bold',
	                    fontSize: 14
	                }
	            }
	        },
	        labelLine: {
	            normal: {
	                show: false
	            }
	        },
	        data: data
	    }, {
	        type: 'pie',
	        radius: ['58%', '83%'],
	        itemStyle: {
	            normal: {
	                color: '#DCDCDC'
	            },
	            emphasis: {
	                color: '#ADADAD'
	            }
	        },
	        label: {
	            normal: {
	                position: 'inner',
	                formatter: '{c}台',
	                textStyle: {
	                    color: '#777777',
	                    fontWeight: 'bold',
	                    fontSize: 14
	                }
	            }
	        },
	        data : data
	    }]
	};
	myChart.setOption(option);
	HYX.tdaEncbandanalysisPage.bindEncOneAreaPage();
  };
  
  /**
   * 绑定饼图点击事件以及银行选择事件
   */
  var bindEncOneAreaPage=function(){
  	if(null != myChart){
  		myChart.on('click', function (params) {
	    	var name = params.data.name;
	    	HYX.tdaEncbandanalysisinfoPage.goToTdaEncbandanalysisinfoPage(tdaEncbandanalysisPage_region,name);
		});
	
		myChart.on('legendselectchanged', function (params) {
			var myChartData=myChart.getOption();
			var _myChartData=myChartData.series[0].data;
			var total=0;
			for(var i=0;i<_myChartData.length;i++){
				var name=_myChartData[i].name;
				if(params.selected[name]){
					total+=Number(_myChartData[i].value);
				}
			}
			
			if(total === 0){
				total="无";
			}
			myChart.setOption({
			    title: {
		        	subtext: total
			    }
			});
		});
  	}
  };
  return {
    goToTdaEncbandanalysisPageMethod : goToTdaEncbandanalysisPageMethod,
    initTdaEncbandanalysisData:initTdaEncbandanalysisData,
    loadEncOneAreaPageData:loadEncOneAreaPageData,
    bindEncOneAreaPage:bindEncOneAreaPage
  };
})();
